Anonymous Login
2020-09-24 09:33 UTC

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0001770OpenClonkEngine - Controlspublic2016-08-09 23:21
Reporterala 
Assigned ToClonkonaut 
PrioritynormalSeverityminorReproducibilityalways
StatusresolvedResolutionfixed 
Product Version 
Target VersionFixed in Version 
Summary0001770: Climbing to walking transition error with pressing up
DescriptionThis is a very annoying bug discovered by Happy Striker in the forum: http://forum.openclonk.org/topic_show.pl?tid=3233

You can climb a loam bridge (for example) with the buttons up or with the direction key towards the direction of the loam bridge.

If you use the left/right key for climbing there is no problem, but if you use "up" the Clonk will be staying in the air at the transition zone, probably switching between both actions back and forth. I was able to reproduce this on first try with 7.0
Steps To ReproduceClimb up a loam bridge with the "up" button.
Additional InformationOriginal German Message:

- Das Klettern auf eine Metall- bzw Lehmwand hakelt ein wenig, wenn man beim klettern die Pfeiltaste oben verwendet.
TagsNo tags attached.
Attached Files

-Relationships
+Relationships

-Notes

~0005243

occ (reporter)

Hi! There's been a check-in that references this bug. For more information you can visit the repository browser at this address:
https://git.openclonk.org/openclonk.git/commitdiff/825c0653e547f6e8df7f63059fd6cff7a1a83683

Changeset 825c065 by Clonkonaut <Armag3ddon@web.de>
Added a slight helper for corner scaling when just pressing up (0001770, 0001630).

The problem occurred as soon as the clonk's leg vertices passed the edge. It seems the engine does not really align the bottom vertex to the material. However, the bottom vertex does have CNAT_Bottom & _Left & _Right, in theory it should be properly attached. Maybe this is a little bit broken engine-wise or maybe assigning both left and right to a vertex isn't supported?
Because the lower vertex (foot vertex) isn't attached, the clonk falls down onto its leg vertex and gets stuck in an endless loop of Scale, Jump, Walk, Scale, ...
When pressing left/right, this is no problem as the clonk will be pushed towards the edge when walking and soon touch it with its foot vertex (I assume at this point regular engine behaviour kicks in).

I added a little helper in the scale effect that sets COMD_UpLeft / UpRight whenever this situation is detected and only Up is pressed. 2 frames (1 is not enough) after the effect ended, the ComDir will reset to COMD_Up. It is then possible to climb an edge and stand still on top of it.

Maybe not a perfect solution (a perfect solution would probably be to fix attachment in the engine but I couldn't pinpoint the exact problem) but it works for now.

~0005246

Clonkonaut (developer)

Fixed for now, let's see when it breaks again!
+Notes

-Issue History
Date Modified Username Field Change
2016-06-26 22:46 ala New Issue
2016-06-26 22:46 ala File Added: Climbing to walking transition error.png
2016-08-09 23:19 occ Note Added: 0005243
2016-08-09 23:21 Clonkonaut Note Added: 0005246
2016-08-09 23:21 Clonkonaut Status new => resolved
2016-08-09 23:21 Clonkonaut Resolution open => fixed
2016-08-09 23:21 Clonkonaut Assigned To => Clonkonaut
+Issue History